﻿using DEVSsharp;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stefan_Stamenkovic_91_2014.Models
{
    class Printer : Atomic
    {
        private StreamWriter writer;
        private List<Porcupine> porcupines;

        public InputPort InputPrint { get; }

        public Printer(string name, TimeUnit tu, List<Porcupine> porcupines) : base(name, tu)
        {
            this.porcupines = porcupines;

            InputPrint = AddIP("InputPrint");
        }

        public override bool delta_x(PortValue x)
        {
            StringBuilder line = new StringBuilder();
            line.Append(TimeCurrent);

            for (int i = 0; i < porcupines.Count; i++)
            {
                line.Append(String.Format(",{0},{1},{2}", porcupines[i].Position.X, porcupines[i].Position.Y, porcupines[i].Position.Z));
            }
            
            writer.WriteLine(line.ToString());

            writer.Flush();

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override void init()
        {
            string path = "./output.csv";

            if(File.Exists(path))
            {
                File.Delete(path);
            }

            writer = new StreamWriter(File.Create(path));

            StringBuilder header = new StringBuilder();
            StringBuilder line = new StringBuilder();

            header.Append("Vreme");
            line.Append(TimeCurrent);

            for(int i=0;i<porcupines.Count;i++)
            {
                header.Append(String.Format(",X{0},Y{0},Z{0}", i));
                line.Append(String.Format(",{0},{1},{2}", porcupines[i].Position.X, porcupines[i].Position.Y, porcupines[i].Position.Z));
            }

            writer.WriteLine(header.ToString());
            writer.WriteLine(line.ToString());

            writer.Flush();
        }

        public override double tau()
        {
            return Double.MaxValue;
        }
    }
}
