﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DEVSsharp;
using System.IO;

namespace Rad
{
   public enum Stanja
    {
        IdemNormalno, IdemKaPrasetu, Cekam
    }
    public class Partner
    {
        public double x, y, z;
        public int id;
        public Partner(double x, double y, double z, int id)
        {
            this.x = x;
            this.y = y;
            this.z = z;
            this.id = id;
        }
        public Partner(double x, double y, double z)
        {
            this.x = x;
            this.y = y;
            this.z = z;
            this.id = id;
        }
    }
   public class Prase : Atomic
    {



        public double T;
        public static int brojac = 0;
        public int id;
        public double eps, kv;
        Double x, y, z;
        public InputPort inputT;
        
        public double V = 0,dvid;
        public OutputPort outputV;
        public OutputPort outputPotraga;
        public InputPort inputPotraga;
        public OutputPort outputOdgovor;
        public InputPort inputOdgovor;
        public OutputPort outputPozicija;
      
        public OutputPort outputCekaj;
        public InputPort inputCekaj;
        public InputPort inputZagrejaoSamSe;
        public OutputPort outputZagrejaoSamSe;
        public OutputPort outputBlizuSamPraseta;
        public OutputPort nisamBlizuPraseta;
        bool jaCekam = false;
        bool partnerCeka = false;
        Partner partner = null;
        Double Tmin;
        double dmin;
        Stanja stanje;
        double Vmax = 20;
        double Vmin = 1.0;
        List<PortValue> msgBuf;

        public Prase(string name, TimeUnit tu, double eps, double x, double y, double z, double dvid) 
            : base(name, tu)
        {
            id = brojac++;
            this.eps = eps;
            stanje = Stanja.IdemNormalno;
            kv = 2.0;
            inputT = AddIP("inputT");
           
            Tmin = 5.0;
            //proba
            dvid = 5000;
            //
            outputPotraga = AddOP("outputPotraga");
            inputPotraga = AddIP("inputPotraga");

            outputOdgovor = AddOP("outputOdgovor");

            inputOdgovor = AddIP("inputOdgovor");


            outputZagrejaoSamSe = AddOP("outputZagrejaoSamSe");
            inputZagrejaoSamSe = AddIP("inputZagrejaoSamSe");

            outputCekaj = AddOP("outputCekaj");
            inputCekaj = AddIP("inputCekaj");

          

            outputV = AddOP("outputV");

            outputPozicija = AddOP("outputPozicija");

            outputBlizuSamPraseta = AddOP("outputBlizuSamPraseta");

            nisamBlizuPraseta = AddOP("nisamBlizuPraseta");
            this.x = x;
            this.y = y;
            this.z = z;
            this.dvid = dvid;
            dmin = 2000.0;
            V = Vmin;
        }

        public override void init()
        {


            msgBuf = new List<PortValue>();

            msgBuf.Add(new PortValue(outputV, T)); //saljem brzinu temperaturi

        }

        public override bool delta_x(PortValue x)
        {
            String[] s = new String[1];
            s[0] = x.port.Name;
            File.AppendAllLines("C:\\Users\\student\\Desktop\\out2.txt", s);
            if (x.port == inputT)
            {
                //promenila mi se temperatura

                double T = ((TemperaturaPoruka)x.value).T;
                if (T < Tmin && stanje == Stanja.IdemNormalno ) //hladno je krecem da trazim prase
                {
                    
                    stanje = Stanja.IdemKaPrasetu;
                    msgBuf.Add(new PortValue(outputPotraga, new TrazimPomoc(this.x, y, z, dvid)));


                }
                else if (T >= Tmin && stanje == Stanja.IdemKaPrasetu )
                {


                   stanje = Stanja.IdemNormalno;
                    

                }
                else if(T>=Tmin && stanje == Stanja.Cekam)
                {
                    jaCekam = false;
                    if (!partnerCeka) stanje = Stanja.IdemNormalno;
                    msgBuf.Add(new PortValue(outputZagrejaoSamSe, new ZagrejaoSamSe(id))); //javi partneru da sam se zagrejao
                }

                return true;
            }
            else if(x.port == inputZagrejaoSamSe)
            {
                //partner mi javlja da mu je toplo
                if (partner.id == ((ZagrejaoSamSe)x.value).id)
                {
                    partnerCeka = false;
                    if (!jaCekam) stanje = Stanja.IdemNormalno;
                }
                return true;
            }

            else if(x.port == inputPotraga)
            {
              
                //drugo prase me je pitalo za lokaciju, saljem samo ako sam mu u vidokrugu

                TrazimPomoc lokacija = (TrazimPomoc)x.value;
               //if(rastojanje(lokacija.x,lokacija.y,lokacija.z) <= lokacija.dvid)
                    msgBuf.Add(new PortValue(outputOdgovor, new Odgovor(this.x, y, z, dvid,this.id)));
                 
                return true;
            }

            else if(x.port == inputOdgovor && stanje == Stanja.IdemKaPrasetu)
            {


             
                //prethodno sam trazio lokaciju, sada mi stize odgovor

                Odgovor odg = (Odgovor)x.value;
                /*/proba
                this.x = odg.x;
                this.y = odg.y;
                this.z = odg.z;
                /*/
                if (partner == null || rastojanje(partner.x,partner.y,partner.z) > rastojanje(odg.x,odg.y,odg.z))
                {
                    partner = new Partner(odg.x, odg.y, odg.z,odg.id);

                    

                }
                return true;

            }
            else if (x.port == inputCekaj)
            {

                Cekaj c = (Cekaj)x.value;
                if(c.id == this.id)
                {
                    this.stanje = Stanja.Cekam;
                }
                return true;
            }

            return false;
        }

        private double rastojanje(double xx, double yy, double zz)
        {
            return Math.Sqrt((this.x - xx) * (this.x - xx) + (this.y - yy) * (this.y - yy) + (this.z - zz) * (this.z - zz));
        }

        public override void delta_y(ref PortValue y)
        {
            if (msgBuf.Count() > 0)
            {
                String[] s = new String[1];

                s[0] = msgBuf[0].port.Name;
                File.AppendAllLines("C:\\Users\\student\\Desktop\\out.txt", s);

                
                
                y = msgBuf[0];
                msgBuf.RemoveAt(0);

                return;
            }

            IzracunajPoziciju(TimeElapsed);

            msgBuf.Add(new PortValue(outputPozicija, new Pozicija(this.x,this.y,z,id,stanje)));
        }

        private void IzracunajPoziciju(double dt)
        {
            Console.WriteLine("dsad");
            if(stanje == Stanja.IdemNormalno)
            {
                //samo sam stavio da se nasumicno krece, nisam radio proracune za nagib
                V = new Random().NextDouble()*10;

                
                if (V > Vmax) V = Vmax;
                if (V < Vmin) V = Vmin;
                msgBuf.Add(new PortValue(outputV, V));
                this.x += kv * V *dt;
                this.y += kv * V*dt;
                this.z += kv * V*dt;

            }
            else if(stanje == Stanja.IdemKaPrasetu)
            {
                //...
                V = new Random().NextDouble()*10;
                
                if (V > Vmax) V = Vmax;
                if (V < Vmin) V = Vmin;
                msgBuf.Add(new PortValue(outputV, V));
                this.x += kv * V * dt;
                this.y += kv * V * dt;
                this.z += kv * V * dt;
                /*/proba
                if (partner != null)
                {
                    Console.WriteLine("AAA");
                    this.x = partner.x;
                    this.y = partner.y;
                    this.z = partner.z;
                }
                /*/
                if (partner!= null && rastojanje(partner.x, partner.y, partner.z) <= dmin)
                {
                 
                    jaCekam = true;
                    partnerCeka = true;
                    this.stanje = Stanja.Cekam;
                    msgBuf.Add(new PortValue(outputCekaj, new Cekaj(partner.id)));
                    msgBuf.Add(new PortValue(outputBlizuSamPraseta, null));

                }
               
                else
                {
                    // proveravam da mi posle pomeranja neko nije blizi
                    partner = null;
                    msgBuf.Add(new PortValue(nisamBlizuPraseta, null));
                    msgBuf.Add(new PortValue(outputPotraga, new TrazimPomoc(this.x, y, z, dvid)));
                }
            }
        }

        public override double tau()
        {
            if (msgBuf.Count() > 0)
            {
                
                return 0.0;


            }

            return eps / V;
        }

        public override string Get_s()
        {
           if(partner!=null) return "X: " + this.x + " Y: " + this.y + " Z: " + this.z+" Stanje: "+this.stanje + " "+partner.x+" "+partner.y+" "+partner.z;
            return "X: " + this.x + " Y: " + this.y + " Z: " + this.z + " Stanje: " + this.stanje;
        }
    }
}

