﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;
using System.IO;

namespace Rad
{
    public class Printer : Atomic
    {
        public string fileName;

        StreamWriter sw;

        int n;
        public InputPort inputT;
        public InputPort inputPoz;
        public double prevTime=-1;
        double T = 5.0,X=-1,Y=-1,Z=-1;

        Pozicija[] pozicije;
        TemperaturaPoruka[] temperature;
        public Printer(string name, TimeUnit tu, string fileName,int n) 
            : base(name, tu)
        {
            this.fileName = fileName;

            inputT = AddIP("inputT");
            inputPoz = AddIP("inputPoz");
            pozicije = new Pozicija[n];
            temperature = new TemperaturaPoruka[n];
            this.n = n;
            for(int i = 0; i<n; i++)
            {
                temperature[i] = new TemperaturaPoruka(5, i);
                pozicije[i] = new Pozicija(0, i, 0, i,Stanja.IdemNormalno);
            }
        }

        public override void init()
        {
            if (sw != null)
                sw.Close();

            sw = new StreamWriter(fileName);

            
        }

        public override bool delta_x(PortValue x)
        {
            if(x.port == inputT)
            {
                TemperaturaPoruka t = (TemperaturaPoruka)x.value;
                temperature[t.id] = t;
                
            }
            else if(x.port == inputPoz)
            {
                Pozicija p = (Pozicija)x.value;
                pozicije[p.id] = p;
            }
            
            String s = TimeCurrent + ",";
            if (TimeCurrent != prevTime)
            {
                for (int i = 0; i < n; i++) s += pozicije[i].x + "," + pozicije[i].y + "," + pozicije[i].z + "," + temperature[i].T+", "+pozicije[i].stanje;

                sw.WriteLine(s);
                sw.Flush();
                prevTime = TimeCurrent;
            }

            return false;
        }

        public override void delta_y(ref PortValue y)
        {
            throw new NotImplementedException();
        }

        public override double tau()
        {
            return double.MaxValue;
        }
    }
}
