﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DEVSsharp;

namespace Rad
{
    public class Sistem : Coupled
    {
        public InputPort inputTs;

        public Sistem(string name) 
            : base(name)
        {
            int n = 3;
            Temperatura[] t = new Temperatura[n];
            Prase[] p = new Prase[n];
            Printer s = new Printer("S", TimeUnit.Sec, "C:\\Users\\student\\Desktop\\simulacija.csv",n);

            this.AddModel(s);
            inputTs = AddIP("inputTs");
            for (int i = 0; i < n; i++)
            {
                p[i] = new Prase("P" + i,TimeUnit.Sec, 0.2, 0, i, 0, i * 5);
                t[i] = new Temperatura("T"+i,TimeUnit.Sec, 0.5, 5.0, p[i].id);
                
                this.AddModel(t[i]);
                this.AddModel(p[i]);
               

                this.AddCP(t[i].outputT, s.inputT); //stampanje temperature
                this.AddCP(t[i].outputT, p[i].inputT); //obavesti prase o promeni temperature
                this.AddCP(inputTs, t[i].inputT); //promena temperature spoljasnje sredine
                this.AddCP(p[i].outputPozicija,s.inputPoz ); //stampanje promene pozicije
                this.AddCP( p[i].outputV, t[i].inputV); //temperatura reaguje na promenu brzine
                this.AddCP(p[i].outputBlizuSamPraseta, t[i].inputBlizuSam); //javi da treba da deli ks sa 2
                this.AddCP(p[i].nisamBlizuPraseta, t[i].inputNisamBlizu); //javi da ne treba da deli ks sa 2





            }


            for(int i = 0; i < n; i++)
            {

                for (int j = 0; i < n; i++)
                {
                    if (i != j)
                    {
                        this.AddCP(p[i].outputCekaj, p[j].inputCekaj);
                        this.AddCP(p[i].outputOdgovor, p[j].inputOdgovor);
                        this.AddCP(p[i].outputPotraga, p[j].inputPotraga);

                        this.AddCP(p[i].outputZagrejaoSamSe, p[j].inputZagrejaoSamSe);
                    }
                }
            }

           

           
            this.PrintCouplings();
        }
    }
}
